Index: /pjproject/branches/users/nanang/pjmedia/build/pjmedia.dsp
===================================================================
--- /pjproject/branches/users/nanang/pjmedia/build/pjmedia.dsp	(revision 1698)
+++ /pjproject/branches/users/nanang/pjmedia/build/pjmedia.dsp	(revision 1699)
@@ -43,5 +43,5 @@
 F90=df.exe
 # ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_MBCS" /D "_LIB" /YX /FD /c
-# ADD CPP /nologo /MD /W4 /GX /Zi /O2 /I "../include" /I "../../pjlib/include" /I "../../pjlib-util/include" /I "../../pjnath/include" /I "../../third_party/portaudio/include" /I "../../third_party/speex/include" /I "../.." /D "NDEBUG" /D "WIN32" /D "_MBCS" /D "_LIB" /D PJ_WIN32=1 /D PJ_M_I386=1 /FR /FD /c
+# ADD CPP /nologo /MD /W4 /GX /Zi /O2 /I "../include" /I "../../pjlib/include" /I "../../pjlib-util/include" /I "../../pjnath/include" /I "../../third_party/portaudio/include" /I "../../third_party/speex/include" /I "../../third_party/build/srtp" /I "../../third_party/srtp/crypto/include" /I "../../third_party/srtp/include" /I "../.." /D "NDEBUG" /D "WIN32" /D "_MBCS" /D "_LIB" /D PJ_WIN32=1 /D PJ_M_I386=1 /FR /FD /c
 # SUBTRACT CPP /YX
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
@@ -68,5 +68,5 @@
 F90=df.exe
 # ADD BASE CPP /nologo /W3 /Gm /GX /ZI /Od /D "WIN32" /D "_DEBUG" /D "_MBCS" /D "_LIB" /YX /FD /GZ /c
-# ADD CPP /nologo /MTd /W4 /Gm /GX /ZI /Od /I "../include" /I "../../pjlib/include" /I "../../pjlib-util/include" /I "../../pjnath/include" /I "../../third_party/portaudio/include" /I "../../third_party/speex/include" /I "../.." /D "_DEBUG" /D "WIN32" /D "_MBCS" /D "_LIB" /D PJ_WIN32=1 /D PJ_M_I386=1 /FR /FD /GZ /c
+# ADD CPP /nologo /MTd /W4 /Gm /GX /ZI /Od /I "../include" /I "../../pjlib/include" /I "../../pjlib-util/include" /I "../../pjnath/include" /I "../../third_party/portaudio/include" /I "../../third_party/speex/include" /I "../../third_party/build/srtp" /I "../../third_party/srtp/crypto/include" /I "../../third_party/srtp/include" /I "../.." /D "_DEBUG" /D "WIN32" /D "_MBCS" /D "_LIB" /D PJ_WIN32=1 /D PJ_M_I386=1 /FR /FD /GZ /c
 # SUBTRACT CPP /YX
 # ADD BASE RSC /l 0x409 /d "_DEBUG"
@@ -250,4 +250,8 @@
 # Begin Source File
 
+SOURCE=..\src\pjmedia\transport_srtp.c
+# End Source File
+# Begin Source File
+
 SOURCE=..\src\pjmedia\transport_udp.c
 # End Source File
@@ -407,4 +411,8 @@
 
 SOURCE=..\include\pjmedia\transport_ice.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjmedia\transport_srtp.h
 # End Source File
 # Begin Source File
Index: /pjproject/branches/users/nanang/pjproject.dsw
===================================================================
--- /pjproject/branches/users/nanang/pjproject.dsw	(revision 1698)
+++ /pjproject/branches/users/nanang/pjproject.dsw	(revision 1699)
@@ -4,101 +4,113 @@
 ###############################################################################
 
-Project: "libgsmcodec"=.\THIRD_PARTY\BUILD\GSM\libgsmcodec.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-}}}
-
-Package=<4>
-{{{
-}}}
-
-###############################################################################
-
-Project: "libilbccodec"=.\THIRD_PARTY\BUILD\ILBC\libilbccodec.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-}}}
-
-Package=<4>
-{{{
-}}}
-
-###############################################################################
-
-Project: "libmilenage"=.\third_party\build\milenage\libmilenage.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-}}}
-
-Package=<4>
-{{{
-}}}
-
-###############################################################################
-
-Project: "libportaudio"=.\THIRD_PARTY\BUILD\PORTAUDIO\libportaudio.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-}}}
-
-Package=<4>
-{{{
-}}}
-
-###############################################################################
-
-Project: "libresample"=.\THIRD_PARTY\BUILD\RESAMPLE\libresample.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-}}}
-
-Package=<4>
-{{{
-}}}
-
-###############################################################################
-
-Project: "libresample_dll"=.\THIRD_PARTY\BUILD\RESAMPLE\libresample_dll.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-}}}
-
-Package=<4>
-{{{
-}}}
-
-###############################################################################
-
-Project: "libspeex"=.\third_party\build\speex\libspeex.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-}}}
-
-Package=<4>
-{{{
-}}}
-
-###############################################################################
-
-Project: "pjlib"=.\pjlib\build\pjlib.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-}}}
-
-Package=<4>
-{{{
-}}}
-
-###############################################################################
-
-Project: "pjlib_test"=.\pjlib\build\pjlib_test.dsp - Package Owner=<4>
+Project: "libgsmcodec"=".\THIRD_PARTY\BUILD\GSM\libgsmcodec.dsp" - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
+Project: "libilbccodec"=".\THIRD_PARTY\BUILD\ILBC\libilbccodec.dsp" - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
+Project: "libmilenage"=".\third_party\build\milenage\libmilenage.dsp" - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
+Project: "libportaudio"=".\THIRD_PARTY\BUILD\PORTAUDIO\libportaudio.dsp" - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
+Project: "libresample"=".\THIRD_PARTY\BUILD\RESAMPLE\libresample.dsp" - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
+Project: "libresample_dll"=".\THIRD_PARTY\BUILD\RESAMPLE\libresample_dll.dsp" - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
+Project: "libspeex"=".\third_party\build\speex\libspeex.dsp" - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
+Project: "libsrtp"=".\third_party\build\srtp\libsrtp.dsp" - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
+Project: "pjlib"=".\pjlib\build\pjlib.dsp" - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
+Project: "pjlib_test"=".\pjlib\build\pjlib_test.dsp" - Package Owner=<4>
 
 Package=<5>
@@ -145,65 +157,65 @@
 ###############################################################################
 
-Project: "pjmedia"=.\pjmedia\build\pjmedia.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-}}}
-
-Package=<4>
-{{{
-}}}
-
-###############################################################################
-
-Project: "pjmedia_codec"=.\pjmedia\build\pjmedia_codec.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-}}}
-
-Package=<4>
-{{{
-}}}
-
-###############################################################################
-
-Project: "pjnath"=.\pjnath\build\pjnath.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-}}}
-
-Package=<4>
-{{{
-}}}
-
-###############################################################################
-
-Project: "pjsip_core"=.\pjsip\build\pjsip_core.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-}}}
-
-Package=<4>
-{{{
-}}}
-
-###############################################################################
-
-Project: "pjsip_simple"=.\pjsip\build\pjsip_simple.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-}}}
-
-Package=<4>
-{{{
-}}}
-
-###############################################################################
-
-Project: "pjsip_ua"=.\pjsip\build\pjsip_ua.dsp - Package Owner=<4>
+Project: "pjmedia"=".\pjmedia\build\pjmedia.dsp" - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
+Project: "pjmedia_codec"=".\pjmedia\build\pjmedia_codec.dsp" - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
+Project: "pjnath"=".\pjnath\build\pjnath.dsp" - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
+Project: "pjsip_core"=".\pjsip\build\pjsip_core.dsp" - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
+Project: "pjsip_simple"=".\pjsip\build\pjsip_simple.dsp" - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
+Project: "pjsip_ua"=".\pjsip\build\pjsip_ua.dsp" - Package Owner=<4>
 
 Package=<5>
@@ -270,9 +282,12 @@
     Project_Dep_Name libmilenage
     End Project Dependency
-}}}
-
-###############################################################################
-
-Project: "pjsua_lib"=.\pjsip\build\pjsua_lib.dsp - Package Owner=<4>
+    Begin Project Dependency
+    Project_Dep_Name libsrtp
+    End Project Dependency
+}}}
+
+###############################################################################
+
+Project: "pjsua_lib"=".\pjsip\build\pjsua_lib.dsp" - Package Owner=<4>
 
 Package=<5>
@@ -394,5 +409,5 @@
 ###############################################################################
 
-Project: "test_pjsip"=.\pjsip\build\test_pjsip.dsp - Package Owner=<4>
+Project: "test_pjsip"=".\pjsip\build\test_pjsip.dsp" - Package Owner=<4>
 
 Package=<5>
Index: /pjproject/branches/users/nanang/third_party/build/srtp/config.h
===================================================================
--- /pjproject/branches/users/nanang/third_party/build/srtp/config.h	(revision 1698)
+++ /pjproject/branches/users/nanang/third_party/build/srtp/config.h	(revision 1699)
@@ -1,3 +1,194 @@
-#ifdef _WIN32
-#include "../../srtp/config.hw"
+/* config.h for Win32/MSVC */
+
+/* Define if building for a CISC machine (e.g. Intel). */
+#define CPU_CISC 1
+
+/* Define if building for a RISC machine (assume slow byte access). */
+/* #undef CPU_RISC */
+
+/* Path to random device */
+/* #define DEV_URANDOM "/dev/urandom" */
+
+/* Define to compile in dynamic debugging system. */
+#define ENABLE_DEBUGGING 1
+
+/* Report errors to this file. */
+/* #undef ERR_REPORTING_FILE */
+
+/* Define to use logging to stdout. */
+#define ERR_REPORTING_STDOUT 1
+
+/* Define this to use ISMAcryp code. */
+/* #undef GENERIC_AESICM */
+
+/* Define to 1 if you have the <arpa/inet.h> header file. */
+/* #undef HAVE_ARPA_INET_H */
+
+/* Define to 1 if you have the <byteswap.h> header file. */
+/* #undef HAVE_BYTESWAP_H */
+
+/* Define to 1 if you have the `inet_aton' function. */
+/* #undef HAVE_INET_ATON */
+
+/* Define to 1 if the system has the type `int16_t'. */
+#define HAVE_INT16_T 1
+
+/* Define to 1 if the system has the type `int32_t'. */
+#define HAVE_INT32_T 1
+
+/* Define to 1 if the system has the type `int8_t'. */
+#define HAVE_INT8_T 1
+
+/* Define to 1 if you have the <inttypes.h> header file. */
+/* #undef HAVE_INTTYPES_H */
+
+/* Define to 1 if you have the `socket' library (-lsocket). */
+/* #undef HAVE_LIBSOCKET */
+
+/* Define to 1 if you have the <machine/types.h> header file. */
+/* #undef HAVE_MACHINE_TYPES_H */
+
+/* Define to 1 if you have the <memory.h> header file. */
+#define HAVE_MEMORY_H 1
+
+/* Define to 1 if you have the <netinet/in.h> header file. */
+/* #undef HAVE_NETINET_IN_H */
+
+/* Define to 1 if you have the `socket' function. */
+/* #undef HAVE_SOCKET */
+
+/* Define to 1 if you have the <stdint.h> header file. */
+/* #undef HAVE_STDINT_H */
+
+/* Define to 1 if you have the <stdlib.h> header file. */
+#define HAVE_STDLIB_H 1
+
+/* Define to 1 if you have the <strings.h> header file. */
+#define HAVE_STRINGS_H 1
+
+/* Define to 1 if you have the <string.h> header file. */
+#define HAVE_STRING_H 1
+
+/* Define to 1 if you have the <syslog.h> header file. */
+/* #undef HAVE_SYSLOG_H */
+
+/* Define to 1 if you have the <sys/int_types.h> header file. */
+/* #undef HAVE_SYS_INT_TYPES_H */
+
+/* Define to 1 if you have the <sys/socket.h> header file. */
+/* #undef HAVE_SYS_SOCKET_H */
+
+/* Define to 1 if you have the <sys/stat.h> header file. */
+#define HAVE_SYS_STAT_H 1
+
+/* Define to 1 if you have the <sys/types.h> header file. */
+#define HAVE_SYS_TYPES_H 1
+
+/* Define to 1 if you have the <sys/uio.h> header file. */
+/* #undef HAVE_SYS_UIO_H */
+
+/* Define to 1 if the system has the type `uint16_t'. */
+#define HAVE_UINT16_T 1
+
+/* Define to 1 if the system has the type `uint32_t'. */
+#define HAVE_UINT32_T 1
+
+/* Define to 1 if the system has the type `uint64_t'. */
+#define HAVE_UINT64_T 1
+
+/* Define to 1 if the system has the type `uint8_t'. */
+#define HAVE_UINT8_T 1
+
+/* Define to 1 if you have the <unistd.h> header file. */
+/* #undef HAVE_UNISTD_H */
+
+/* Define to 1 if you have the `usleep' function. */
+/* #undef HAVE_USLEEP */
+
+/* Define to 1 if you have the <windows.h> header file. */
+#define HAVE_WINDOWS_H 1
+
+/* Define to 1 if you have the <winsock2.h> header file. */
+#define HAVE_WINSOCK2_H 1
+
+/* Define to use X86 inlined assembly code */
+/* #undef HAVE_X86 */
+
+/* Define to the address where bug reports for this package should be sent. */
+#define PACKAGE_BUGREPORT ""
+
+/* Define to the full name of this package. */
+#define PACKAGE_NAME ""
+
+/* Define to the full name and version of this package. */
+#define PACKAGE_STRING ""
+
+/* Define to the one symbol short name of this package. */
+#define PACKAGE_TARNAME ""
+
+/* Define to the version of this package. */
+#define PACKAGE_VERSION ""
+
+/* The size of a `unsigned long', as computed by sizeof. */
+#define SIZEOF_UNSIGNED_LONG 4
+
+/* The size of a `unsigned long long', as computed by sizeof. */
+#define SIZEOF_UNSIGNED_LONG_LONG 8
+
+/* Define to use GDOI. */
+/* #undef SRTP_GDOI */
+
+/* Define to compile for kernel contexts. */
+/* #undef SRTP_KERNEL */
+
+/* Define to compile for Linux kernel context. */
+/* #undef SRTP_KERNEL_LINUX */
+
+/* Define to 1 if you have the ANSI C header files. */
+#define STDC_HEADERS 1
+
+/* Write errors to this file */
+/* #undef USE_ERR_REPORTING_FILE */
+
+/* Define to use syslog logging. */
+/* #undef USE_SYSLOG */
+
+/* Define to 1 if your processor stores words with the most significant byte
+   first (like Motorola and SPARC, unlike Intel and VAX). */
+/* #undef WORDS_BIGENDIAN */
+
+/* Define to empty if `const' does not conform to ANSI C. */
+/* #undef const */
+
+/* Define 'inline' to nothing, since the MSVC compiler doesn't support it.  */
+#define inline 
+
+/* Define to `unsigned' if <sys/types.h> does not define. */
+/* #undef size_t */
+
+#if (_MSC_VER >= 1400) // VC8+
+#   ifndef _CRT_SECURE_NO_DEPRECATE
+#	define _CRT_SECURE_NO_DEPRECATE
+#   endif
+#   ifndef _CRT_NONSTDC_NO_DEPRECATE
+#	define _CRT_NONSTDC_NO_DEPRECATE
+#   endif
+#endif // VC8+
+
+#ifndef uint32_t
+    typedef unsigned char	uint8_t;
+    typedef unsigned short	uint16_t;
+    typedef unsigned int	uint32_t;
+    typedef unsigned __int64    uint64_t;
+    typedef signed char		int8_t;
+    typedef short		int16_t;
+    typedef int			int32_t;
+    typedef __int64		int64_t;
 #endif
+
+#ifdef _MSC_VER
+    #pragma warning(disable:4311)
+    #pragma warning(disable:4761) // integral mismatch
+    #pragma warning(disable:4018) // signed/unsigned mismatch
+    #pragma warning(disable:4244) // conversion from int64 to int
+#endif
Index: /pjproject/branches/users/nanang/third_party/build/srtp/libsrtp.dsp
===================================================================
--- /pjproject/branches/users/nanang/third_party/build/srtp/libsrtp.dsp	(revision 1699)
+++ /pjproject/branches/users/nanang/third_party/build/srtp/libsrtp.dsp	(revision 1699)
@@ -0,0 +1,358 @@
+# Microsoft Developer Studio Project File - Name="libsrtp" - Package Owner=<4>
+# Microsoft Developer Studio Generated Build File, Format Version 6.00
+# ** DO NOT EDIT **
+
+# TARGTYPE "Win32 (x86) Static Library" 0x0104
+
+CFG=libsrtp - Win32 Debug
+!MESSAGE This is not a valid makefile. To build this project using NMAKE,
+!MESSAGE use the Export Makefile command and run
+!MESSAGE 
+!MESSAGE NMAKE /f "libsrtp.mak".
+!MESSAGE 
+!MESSAGE You can specify a configuration when running NMAKE
+!MESSAGE by defining the macro CFG on the command line. For example:
+!MESSAGE 
+!MESSAGE NMAKE /f "libsrtp.mak" CFG="libsrtp - Win32 Debug"
+!MESSAGE 
+!MESSAGE Possible choices for configuration are:
+!MESSAGE 
+!MESSAGE "libsrtp - Win32 Release" (based on "Win32 (x86) Static Library")
+!MESSAGE "libsrtp - Win32 Debug" (based on "Win32 (x86) Static Library")
+!MESSAGE 
+
+# Begin Project
+# PROP AllowPerConfigDependencies 0
+# PROP Scc_ProjName ""
+# PROP Scc_LocalPath ""
+CPP=cl.exe
+RSC=rc.exe
+
+!IF  "$(CFG)" == "libsrtp - Win32 Release"
+
+# PROP BASE Use_MFC 0
+# PROP BASE Use_Debug_Libraries 0
+# PROP BASE Output_Dir "output\libsrtp-i386-win32-vc6-release"
+# PROP BASE Intermediate_Dir "output\libsrtp-i386-win32-vc6-release"
+# PROP BASE Target_Dir ""
+# PROP Use_MFC 0
+# PROP Use_Debug_Libraries 0
+# PROP Output_Dir "output\libsrtp-i386-win32-vc6-release"
+# PROP Intermediate_Dir "output\libsrtp-i386-win32-vc6-release"
+# PROP Target_Dir ""
+F90=df.exe
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_MBCS" /D "_LIB" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I "../../srtp/include" /I "../../srtp/crypto/include" /D "WIN32" /D "NDEBUG" /D "_MBCS" /D "_LIB" /YX /FD /c
+# ADD BASE RSC /l 0x409 /d "NDEBUG"
+# ADD RSC /l 0x409 /d "NDEBUG"
+BSC32=bscmake.exe
+# ADD BASE BSC32 /nologo
+# ADD BSC32 /nologo
+LIB32=link.exe -lib
+# ADD BASE LIB32 /nologo
+# ADD LIB32 /nologo /out:"..\..\lib\libsrtp-i386-vc6-release.lib"
+
+!ELSEIF  "$(CFG)" == "libsrtp - Win32 Debug"
+
+# PROP BASE Use_MFC 0
+# PROP BASE Use_Debug_Libraries 1
+# PROP BASE Output_Dir "output\libsrtp-i386-win32-vc6-debug"
+# PROP BASE Intermediate_Dir "output\libsrtp-i386-win32-vc6-debug"
+# PROP BASE Target_Dir ""
+# PROP Use_MFC 0
+# PROP Use_Debug_Libraries 1
+# PROP Output_Dir "output\libsrtp-i386-win32-vc6-debug"
+# PROP Intermediate_Dir "output\libsrtp-i386-win32-vc6-debug"
+# PROP Target_Dir ""
+F90=df.exe
+# ADD BASE CPP /nologo /W3 /Gm /GX /ZI /Od /D "WIN32" /D "_DEBUG" /D "_MBCS" /D "_LIB" /YX /FD /GZ /c
+# ADD CPP /nologo /MTd /W3 /Gm /GX /ZI /Od /I "." /I "../../srtp/include" /I "../../srtp/crypto/include" /D "WIN32" /D "_DEBUG" /D "_MBCS" /D "_LIB" /YX /FD /GZ /c
+# ADD BASE RSC /l 0x409 /d "_DEBUG"
+# ADD RSC /l 0x409 /d "_DEBUG"
+BSC32=bscmake.exe
+# ADD BASE BSC32 /nologo
+# ADD BSC32 /nologo
+LIB32=link.exe -lib
+# ADD BASE LIB32 /nologo
+# ADD LIB32 /nologo /out:"..\..\lib\libsrtp-i386-vc6-debug.lib"
+
+!ENDIF 
+
+# Begin Target
+
+# Name "libsrtp - Win32 Release"
+# Name "libsrtp - Win32 Debug"
+# Begin Group "Source Files"
+
+# PROP Default_Filter "cpp;c;cxx;rc;def;r;odl;idl;hpj;bat"
+# Begin Source File
+
+SOURCE=..\..\srtp\srtp\srtp.c
+# End Source File
+# End Group
+# Begin Group "Header Files"
+
+# PROP Default_Filter "h;hpp;hxx;hm;inl"
+# Begin Source File
+
+SOURCE=.\config.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\include\rtp.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\include\srtp.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\include\ut_sim.h
+# End Source File
+# End Group
+# Begin Group "crypto"
+
+# PROP Default_Filter ""
+# Begin Group "ae_xfm"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\ae_xfm\xfm.c
+# End Source File
+# End Group
+# Begin Group "cipher"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\cipher\aes.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\cipher\aes_cbc.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\cipher\aes_icm.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\cipher\cipher.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\cipher\null_cipher.c
+# End Source File
+# End Group
+# Begin Group "hash"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\hash\auth.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\hash\hmac.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\hash\null_auth.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\hash\sha1.c
+# End Source File
+# End Group
+# Begin Group "include"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\include\aes.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\include\aes_cbc.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\include\aes_icm.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\include\alloc.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\include\auth.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\include\cipher.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\include\crypto.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\include\crypto_kernel.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\include\crypto_math.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\include\crypto_types.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\include\cryptoalg.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\include\datatypes.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\include\err.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\include\gf2_8.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\include\hmac.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\include\integers.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\include\kernel_compat.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\include\key.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\include\null_auth.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\include\null_cipher.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\include\prng.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\include\rand_source.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\include\rdb.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\include\rdbx.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\include\sha1.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\include\stat.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\include\xfm.h
+# End Source File
+# End Group
+# Begin Group "kernel"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\kernel\alloc.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\kernel\crypto_kernel.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\kernel\err.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\kernel\key.c
+# End Source File
+# End Group
+# Begin Group "math"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\math\datatypes.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\math\gf2_8.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\math\stat.c
+# End Source File
+# End Group
+# Begin Group "replay"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\replay\rdb.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\replay\rdbx.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\replay\ut_sim.c
+# End Source File
+# End Group
+# Begin Group "rng"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\rng\ctr_prng.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\rng\prng.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\srtp\crypto\rng\rand_source.c
+# End Source File
+# End Group
+# End Group
+# Begin Group "tables"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\..\srtp\tables\aes_tables.c
+# End Source File
+# End Group
+# End Target
+# End Project
Index: /pjproject/branches/users/nanang/third_party/build/srtp/libsrtp.vcproj
===================================================================
--- /pjproject/branches/users/nanang/third_party/build/srtp/libsrtp.vcproj	(revision 1698)
+++ /pjproject/branches/users/nanang/third_party/build/srtp/libsrtp.vcproj	(revision 1699)
@@ -162,9 +162,5 @@
 			>
 			<File
-				RelativePath="..\..\srtp\include\config.h"
-				>
-			</File>
-			<File
-				RelativePath=".\config_win32.h"
+				RelativePath=".\config.h"
 				>
 			</File>
Index: /pjproject/branches/users/nanang/third_party/srtp/srtp/srtp.c
===================================================================
--- /pjproject/branches/users/nanang/third_party/srtp/srtp/srtp.c	(revision 1698)
+++ /pjproject/branches/users/nanang/third_party/srtp/srtp/srtp.c	(revision 1699)
@@ -484,5 +484,9 @@
 }
 #else
+#if _MSC_VER <= 1200
+   key_limit_set(srtp->limit, 0xffffffffffffI64);
+#else
    key_limit_set(srtp->limit, 0xffffffffffffLL);
+#endif
 #endif
 